# HG changeset patch
# User Markus Mützel <markus.muetzel@gmx.de>
# Date 1617903126 -7200
#      Thu Apr 08 19:32:06 2021 +0200
# Node ID 73edbbbd450fe3524fbfb583e0c9a316412a8486
# Parent  526a5ba817ca03a741c4ed530fddcc4e1d33fb80
mappers.cc: Skip platform specific BISTs on all other platforms (bug #60357).

* libinterp/corefcn/mappers.cc: Skip platform specific BISTs on all other
  platforms instead of returning early from the BIST.

diff -r 526a5ba817ca -r 73edbbbd450f libinterp/corefcn/mappers.cc
--- a/libinterp/corefcn/mappers.cc	Thu Apr 08 18:14:02 2021 +0200
+++ b/libinterp/corefcn/mappers.cc	Thu Apr 08 19:32:06 2021 +0200
@@ -128,15 +128,14 @@
 
 ## Test large magnitude arguments (bug #45507)
 ## Test fails with older versions of libm, solution is to upgrade.
-%!testif ; ! ismac () && ! ispc ()   <*45507>
+%!testif ; ! ismac () && ! ispc () <*45507>
 %! x = [1, -1, i, -i] .* 1e150;
 %! v = [0, pi, pi/2, pi/2];
 %! assert (real (acos (x)), v);
 
-%!test <52627>
+%!testif ; ismac () || ispc () <52627>
 %! ## Same test code as above, but intended only for test statistics on Mac and
 %! ## Windows.  Their trig/hyperbolic functions have huge tolerances.
-%! if (! ismac () && ! ispc ()), return; endif
 %! x = [1, -1, i, -i] .* 1e150;
 %! v = [0, pi, pi/2, pi/2];
 %! assert (real (acos (x)), v);
@@ -164,10 +163,9 @@
 %! v = [0, pi/2*i, pi*i, pi/2*i];
 %! assert (acosh (x), v, sqrt (eps));
 
-%!test <52627>
+%!testif ; ismac () <52627>
 %! ## Same test code as above, but intended only for test statistics on Mac.
 %! ## Mac trig/hyperbolic functions have huge tolerances.
-%! if (! ismac ()), return; endif
 %! x = [1, 0, -1, 0];
 %! v = [0, pi/2*i, pi*i, pi/2*i];
 %! assert (acosh (x), v, sqrt (eps));
@@ -187,10 +185,9 @@
 %! v = single ([0, pi/2*i, pi*i, pi/2*i]);
 %! assert (acosh (x), v, sqrt (eps ("single")));
 
-%!test <52627>
+%!testif ; ismac () <52627>
 %! ## Same test code as above, but intended only for test statistics on Mac.
 %! ## Mac trig/hyperbolic functions have huge tolerances.
-%! if (! ismac ()), return; endif
 %! x = single ([1, 0, -1, 0]);
 %! v = single ([0, pi/2*i, pi*i, pi/2*i]);
 %! assert (acosh (x), v, sqrt (eps ("single")));
@@ -203,15 +200,14 @@
 
 ## Test large magnitude arguments (bug #45507)
 ## Test fails with older versions of libm, solution is to upgrade.
-%!testif ; ! ismac () && ! ispc ()   <*45507>
+%!testif ; ! ismac () && ! ispc () <*45507>
 %! x = [1, -1, i, -i] .* 1e150;
 %! v = [0, pi, pi/2, -pi/2];
 %! assert (imag (acosh (x)), v);
 
-%!test <52627>
+%!test ; ismac () || ispc () <52627>
 %! ## Same test code as above, but intended only for test statistics on Mac and
 %! ## Windows.  Their trig/hyperbolic functions have huge tolerances.
-%! if (! ismac () && ! ispc ()), return; endif
 %! x = [1, -1, i, -i] .* 1e150;
 %! v = [0, pi, pi/2, -pi/2];
 %! assert (imag (acosh (x)), v);
@@ -331,15 +327,14 @@
 
 ## Test large magnitude arguments (bug #45507)
 ## Test fails with older versions of libm, solution is to upgrade.
-%!testif ; ! ismac () && ! ispc ()   <*45507>
+%!testif ; ! ismac () && ! ispc () <*45507>
 %! x = [1, -1, i, -i] .* 1e150;
 %! v = [pi/2, -pi/2, 0, -0];
 %! assert (real (asin (x)), v);
 
-%!test <52627>
+%!testif ; ismac () || ispc () <52627>
 %! ## Same test code as above, but intended only for test statistics on Mac and
 %! ## Windows. Their trig/hyperbolic functions have huge tolerances.
-%! if (! ismac () && ! ispc ()), return; endif
 %! x = [1, -1, i, -i] .* 1e150;
 %! v = [pi/2, -pi/2, 0, -0];
 %! assert (real (asin (x)), v);
@@ -374,15 +369,14 @@
 
 ## Test large magnitude arguments (bug #45507)
 ## Test fails with older versions of libm, solution is to upgrade.
-%!testif ; ! ismac () && ! ispc ()   <*45507>
+%!testif ; ! ismac () && ! ispc () <*45507>
 %! x = [1, -1, i, -i] .* 1e150;
 %! v = [0, 0, pi/2, -pi/2];
 %! assert (imag (asinh (x)), v);
 
-%!test <52627>
+%!test ; ismac () || ispc () <52627>
 %! ## Same test code as above, but intended only for test statistics on Mac and
 %! ## Windows.  Their trig/hyperbolic functions have huge tolerances.
-%! if (! ismac () && ! ispc ()), return; endif
 %! x = [1, -1, i, -i] .* 1e150;
 %! v = [0, 0, pi/2, -pi/2];
 %! assert (imag (asinh (x)), v);